<template>
    <div class="w-full flex flex-col">
        <div class="flex flex-col m-2 bg-gray-200 p-2 w-full">
            <div class="headline flex flex-row items-center mb-2">
                <div class="text-md uppercase"> Members <span v-if="project.types" class="px-2 text-xs bg-gray-500 text-gray-100 mx-2 rounded-full">{{members.length}}</span> </div>
                <wee-users-autocomplete ref="search" v-on:selected="select"></wee-users-autocomplete>
                <div v-if="selected" class="w-full actions flex-grow text-right">
                    <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="add()">
                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/add-solid.svg" />
                        <span>Add {{selected.name}}</span>
                    </button>
                </div>
            </div>
            <div class="w-full bg-white">
                <table class="relative table-auto w-full">
                    <thead>
                        <tr class="border-b border-gray-200">
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Name</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Since</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Role</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Actions</th>
                        </tr>
                    </thead>
                    <tbody class="bg-white overflow-y-auto w-full">
                        <tr v-for="m in memberships" :key="m.seq">
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <div class="text-sm leading-5 text-gray-700 whitespace-pre-line w-full"><a :href="m.user.profile">{{m.user.first}} {{m.user.last}}</a></div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <div class="text-sm leading-5 text-gray-700 whitespace-pre-line w-full">{{m.since}}</div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <v-select label="name" :options="roles" :reduce="a => a.id" v-model="m.role" :disabled="m.membership == 0" class="w-full"></v-select>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <button v-if="m.membership > 0 && m.prerole != m.role" class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="save(m)">
                                    <img svg-inline src="./pix/zond/save-disk.svg" class="w-4 h-4 fill-current" />
                                </button>
                                <button v-if="m.membership > 0" class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="remove(m)">
                                    <img svg-inline src="./pix/zond/trash.svg" class="w-4 h-4 fill-current" />
                                </button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</template>
<script>
import Vue from 'vue'
import axios from 'axios'
import vSelect from 'vue-select'
import WeeUsersAutocomplete from './WeeUsersAutocomplete'
import 'vue-select/dist/vue-select.css';

Vue.component('v-select', vSelect);

export default {
    name: "WeeSpatialProjectMembershipEditor",
    props: ["project"],
    data(){
        return {
            selected: null,
            memberships: [],
            roles: []
        };
    },
    components: {
        WeeUsersAutocomplete
    },
    created(){
        console.log('WeeSpatialProjectMembershipEditor');
        this.load();
    },
    methods: {
        load(){
            let self = this;
            axios.get(this.membersUrl).then(function(response){
                self.memberships = response.data.memberships.map(function(m){
                    m.user.profile = '/user/profile/'+m.user.id;
                    m.prerole = m.role;
                    return m;
                });
                self.roles = response.data.roles;
            }).catch(function(error){
                console.log(error);
            });
        },
        select(result){
            this.selected = result;
            this.clear();
        },
        clear(){
            this.$refs.search.clear();
        },
        add(){
            let self = this;
            axios.post(this.createUrl+this.selected.id).then(function(response){
                self.load();
            }).catch(function(error){
                console.log(error);
            });
        },
        save(){
            
        }
    },
    computed: {
        membersUrl(){
            return '/projects/members/'+this.project+'/overview';
        },
        createUrl(){
            return '/projects/members/'+this.project+'/create/';
        },
        removeUrl(){
            return '/projects/members/'+this.project+'/remove/';
        }
    }
}
</script>
<style>

</style>
